//****************************************************************************
// et un petit exemple pour comprendre comment tout ce petit monde fonctionne
// ===========================================================================
// Les pid
// ***************************************************************************
#include <Autom.h>
/*
 * Certe une grosse bibliotheque pour 
Seulement un pid
*/

// un objet appli dans lequel on va installer le système de graphes, tempos ....
project appli=project();



// déclaration du pid
pid Pid1=pid(20,10,10,"pid1"); // un pid avec Kp=20 Kd=10 Ki=10

// Les entrés

#define pinOn 2 // le bouton On
boolean boutonOn = false;
boolean boutonOnSto=false;
boolean boutonOnFmt=false;

#define pinledOn 3 // le voyant On

#define pinRetour A0 // le retour d'info sur entrée anna A0
int Retour = 0;

#define pinCommande 6 // la commande en Pwm (0->5v)

// Les procedures à écrire pour décrire le fonctionnement de l'application 
// ***********************************************************************

// Les phases de fonctionnement du système numérique associé
void preliminaire_appli() // calculs preliminaires ex fronts prise de valeurs digitales, analogiques ...
{
	boutonOn=digitalRead(pinOn); // prise de l'état du bouton On
	boutonOnFmt=boutonOn && !boutonOnSto;
	boutonOnSto=boutonOn;
	
	Retour=analogRead(pinRetour)/4; // prise de la valeur du retour et normaliation entre 0 et 255
	Pid1.setFeedBack(Retour);
		
}


void calculEvolution_appli() // préparation de l'évolution des graphes en suivant les transitions
{
 
}

void posterieur_appli() // typiquement affectation des sorties
{

	// Premièrement Traitement des figeages et forcages;


	// Deuxiemement activer les tempos
	
	
	// Troisièmement Traitement des sorties

	// Les bits internes et pid
    if (boutonOnFmt) {Pid1.on();};
	if (!boutonOn) {Pid1.off();};
	// Les sortie tout ou rien externes
	digitalWrite(pinledOn,Pid1.state());
	// La sortie du PID
	digitalWrite(pinCommande,Pid1.out()); // La sortie va de 0 à 255
}

void setup() // initialisation E/S séries ....
{
	pinMode(pinOn,INPUT_PULLUP);
	
	pinMode(pinledOn,OUTPUT);
	
	// Mise en place du mode de debogage sur la sortie serie Serial
	appli.debugMode(&Serial,9600); // mise en place du mode de debogage

	// initialisation de l'application
	// on installe les entités dans l'application

	appli.add(&Pid1);
	Pid1.setDeltaT(50); // toute les 50 ms
	
	// on affecte les fonctions
	appli.setPreliminaire(preliminaire_appli);
	appli.setCalculEvolution(calculEvolution_appli);
	appli.setPosterieur(posterieur_appli);


}


void loop() // Le chef d'orchestre (le vrai !)
{
	// mise à jour obligatoire des variables globales tous les tours de calcul
	initLoop(); 
	
    // et c'est parti tout est intégré dedans !!
	appli.fonctionnement(); 

}


