//****************************************************************************
// et un petit exemple pour comprendre comment tout ce petit monde fonctionne
// ===========================================================================
// Les tempo(s)
// ***************************************************************************
#include <Autom.h>
/*
 * Certe une grosse bibliotheque pour 
Seulement trois temporisateurs
*/

// un objet appli dans lequel on va installer le système de graphes, tempos ....
project appli=project();



// déclaration des tempos
tempo Ton=tempo(tempoTon,3000,"Ton"); // tempo de 3000 ms soit 3 s modele retard enclenchement
tempo Tof=tempo(tempoTof,3000,"Tof"); // tempo de 3000 ms soit 3 s modele retard declenchement
tempo Tp=tempo(tempoTpulse,3000,"Tp"); // tempo de 3000 ms soit 3 s modele pulse

// Les entrés

#define pinTon 2 // le bouton Ton
boolean boutonTon = false;
#define pinledTon 3 // le voyant Ton

#define pinTof 4 // le bouton Ton
boolean boutonTof = false;
#define pinledTof 5 // le voyant Ton

#define pinTp 6 // le bouton Ton
boolean boutonTp = false;
#define pinledTp 7 // le voyant Ton

// Les procedures à écrire pour décrire le fonctionnement de l'application 
// ***********************************************************************

// Les phases de fonctionnement du système numérique associé
void preliminaire_appli() // calculs preliminaires ex fronts prise de valeurs digitales, analogiques ...
{
	boutonTon=digitalRead(pinTon); // prise de l'état du bouton Ton
	boutonTof=digitalRead(pinTof); // prise de l'état du bouton Tofn
	boutonTp=digitalRead(pinTp); // prise de l'état du bouton Tp
	
}


void calculEvolution_appli() // préparation de l'évolution des graphes en suivant les transitions
{

}

void posterieur_appli() // typiquement affectation des sorties
{

	// Premièrement Traitement des figeages et forcages;


	// Deuxiemement activer les tempos
	if (boutonTon) {Ton.active();};
	if (boutonTof) {Tof.active();};
	if (boutonTp) {Tp.active();};

	// Troisièmement Traitement des sorties

	// Les bits internes

	// Les sortie tout ou rien externes
	digitalWrite(pinledTon,Ton.out());
	digitalWrite(pinledTof,Tof.out()); 
	digitalWrite(pinledTp,Tp.out());
}

void setup() // initialisation E/S séries ....
{
	pinMode(pinTon,INPUT_PULLUP);
	pinMode(pinTof,INPUT_PULLUP);
	pinMode(pinTp,INPUT_PULLUP);
	pinMode(pinledTon,OUTPUT);
	pinMode(pinledTof,OUTPUT);
	pinMode(pinledTp,OUTPUT);


	// Mise en place du mode de debogage sur la sortie serie Serial
	appli.debugMode(&Serial,9600); // mise en place du mode de debogage

	// initialisation de l'application
	// on installe les entités dans l'application

	appli.add(&Ton);
	appli.add(&Tof);
	appli.add(&Tp);

	// on affecte les fonctions
	appli.setPreliminaire(preliminaire_appli);
	appli.setCalculEvolution(calculEvolution_appli);
	appli.setPosterieur(posterieur_appli);


}


void loop() // Le chef d'orchestre (le vrai !)
{
	// mise à jour obligatoire des variables globales tous les tours de calcul
	initLoop(); 
	
    // et c'est parti tout est intégré dedans !!
	appli.fonctionnement(); 

}


